<template>
  <div>
    <PageCard>
      <FiveEos
        :ownerKey="publicOwnerKey"
        :activeKey="publicActiveKey"></FiveEos>
    </PageCard>
    <PageCard>
      <SwitchereBlock
        :loadingMemo="loading"
        accountName="popcornmaker"
        :memo="memo"></SwitchereBlock>
    </PageCard>
    <PageCard>
      <PayByEos
        :requiredMemo="true"
        accountName="popcornmaker"
        :memo="memo"></PayByEos>
    </PageCard>
  </div>
</template>

<script>
  import PageCard from '~/components/UI/PageCard';
  import * as base58 from '~/components/utils/bs58.bundle.js';

  import SwitchereBlock from './components/SwitchereBlock';
  import PayByEos from './components/PayByEos';
  import FiveEos from './components/5eos';
  import resourceManager from '~/services/resourceManager';
  import {Wallet} from '~/services/wallet/';

  const toHex = (string) => bs58.decode(string).toString('hex');

  export default {
    name: "Deposit_TheStep3",
    data() {
      return {
        memo: '',
        loading: true,
        publicOwnerKey: '',
        publicActiveKey: ''
      }
    },
    components: {
      SwitchereBlock,
      PayByEos,
      PageCard,
      FiveEos
    },
    methods: {
      async configureMemo() {
        const res = await (this.$store.dispatch(`signIn/_getAccountByKey_testnet`, localStorage.getItem('public')));
        let activePubKey = '';
        let ownerPubKey = '';
        if (res && res.length) {
          const user = await this.$store.dispatch('signIn/checkUserName', {
            name: res[0],
            network: 'testnet',
            needToCommit: false
          });
          if (user.data && user.data.permissions) {
            user.data.permissions.forEach(perm => {
              if (perm.perm_name === 'active') {
                activePubKey = perm.required_auth.keys[0].key;
                this.publicActiveKey = activePubKey;
              }
              if (perm.perm_name === 'owner') {
                ownerPubKey = perm.required_auth.keys[0].key;
                this.publicOwnerKey = ownerPubKey;
              }
            })
          }
        }
        const cpu = resourceManager.calcCpu(20);
        const net = resourceManager.calcNet(10);
        let max_payment = cpu.price;
        const cpu_frac = cpu.frac;
        const net_frac = net.frac;
        max_payment = Math.max(max_payment, net.price) * 1.5 * 10 ** 4;
        const memo = `${localStorage.getItem('accountname')}-${toHex(ownerPubKey.slice(3))}-${toHex((activePubKey || ownerPubKey).slice(3))}-5000-${net_frac}-${cpu_frac}-${max_payment}`;
        this.memo = memo;
        this.loading = false;
      },
    },
    async mounted() {
      await resourceManager.refreshCache();
      this.configureMemo();
    }
  }
</script>
